package com.example.model;

/**
 * An article from the library.
 */
@io.swagger.annotations.ApiModel(value = "Article", description = "An article from the library.")
@javax.xml.bind.annotation.XmlRootElement(name = "Article")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class Article extends com.example.model.ArticleSummary implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.List<com.example.model.ArticleContent> contents = new java.util.ArrayList<com.example.model.ArticleContent>();
	private java.util.List<com.example.model.TopicSummary> topics = new java.util.ArrayList<com.example.model.TopicSummary>();
	private java.util.List<com.example.model.ArticleSummary> relatedArticles = null;
	private com.example.model.Image image = null;
	private com.example.model.Image image2x = null;
	
	/**
	 */
	@java.lang.Override
	public Article id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public Article name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public Article teaser(java.lang.String teaser) {
		setTeaser(teaser);
		return this;
	}
	
	/**
	 * A URL to a thumbnail image for this article.
	 */
	@java.lang.Override
	public Article thumbnail(com.example.model.Image thumbnail) {
		setThumbnail(thumbnail);
		return this;
	}
	
	/**
	 */
	public Article contents(java.util.List<com.example.model.ArticleContent> contents) {
		setContents(contents);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("contents")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<com.example.model.ArticleContent> getContents() {
		return this.contents;
	}
	public void setContents(java.util.List<com.example.model.ArticleContent> contents) {
		this.contents = contents;
	}
	public void addContent(com.example.model.ArticleContent content) {
		if (this.contents == null) {
			this.contents = new java.util.ArrayList<com.example.model.ArticleContent>();
		}
		this.contents.add(content);
	}
	
	/**
	 * The topics that this article belongs to.
	 */
	public Article topics(java.util.List<com.example.model.TopicSummary> topics) {
		setTopics(topics);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "The topics that this article belongs to.")
	@com.fasterxml.jackson.annotation.JsonProperty("topics")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<com.example.model.TopicSummary> getTopics() {
		return this.topics;
	}
	public void setTopics(java.util.List<com.example.model.TopicSummary> topics) {
		this.topics = topics;
	}
	public void addTopic(com.example.model.TopicSummary topic) {
		if (this.topics == null) {
			this.topics = new java.util.ArrayList<com.example.model.TopicSummary>();
		}
		this.topics.add(topic);
	}
	
	/**
	 * Articles related to this article.
	 */
	public Article relatedArticles(java.util.List<com.example.model.ArticleSummary> relatedArticles) {
		setRelatedArticles(relatedArticles);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Articles related to this article.")
	@com.fasterxml.jackson.annotation.JsonProperty("relatedArticles")
	@javax.validation.Valid
	public java.util.List<com.example.model.ArticleSummary> getRelatedArticles() {
		return this.relatedArticles;
	}
	public void setRelatedArticles(java.util.List<com.example.model.ArticleSummary> relatedArticles) {
		this.relatedArticles = relatedArticles;
	}
	public void addRelatedArticle(com.example.model.ArticleSummary relatedArticle) {
		if (this.relatedArticles == null) {
			this.relatedArticles = new java.util.ArrayList<com.example.model.ArticleSummary>();
		}
		this.relatedArticles.add(relatedArticle);
	}
	
	/**
	 * A URL to a hero image for this article.
	 */
	public Article image(com.example.model.Image image) {
		setImage(image);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "A URL to a hero image for this article.")
	@com.fasterxml.jackson.annotation.JsonProperty("image")
	@javax.validation.Valid
	public com.example.model.Image getImage() {
		return this.image;
	}
	public void setImage(com.example.model.Image image) {
		this.image = image;
	}
	
	/**
	 * A URL to a 2x hero image for this article.
	 */
	public Article image2x(com.example.model.Image image2x) {
		setImage2x(image2x);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "A URL to a 2x hero image for this article.")
	@com.fasterxml.jackson.annotation.JsonProperty("image2x")
	@javax.validation.Valid
	public com.example.model.Image getImage2x() {
		return this.image2x;
	}
	public void setImage2x(com.example.model.Image image2x) {
		this.image2x = image2x;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		if (!super.equals(o)) {
			return false;
		}
		Article article = (Article) o;
		return java.util.Objects.equals(this.contents, article.contents) &&
				java.util.Objects.equals(this.topics, article.topics) &&
				java.util.Objects.equals(this.relatedArticles, article.relatedArticles) &&
				java.util.Objects.equals(this.image, article.image) &&
				java.util.Objects.equals(this.image2x, article.image2x);
	}
	
	@Override
	public int hashCode() {
		return 31 * super.hashCode() + java.util.Objects.hash(this.contents, this.topics, this.relatedArticles, this.image, this.image2x);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class Article {\n");
		sb.append("    ").append(toIndentedString(super.toString())).append("\n");
		sb.append("    contents: ").append(toIndentedString(this.contents)).append("\n");
		sb.append("    topics: ").append(toIndentedString(this.topics)).append("\n");
		sb.append("    relatedArticles: ").append(toIndentedString(this.relatedArticles)).append("\n");
		sb.append("    image: ").append(toIndentedString(this.image)).append("\n");
		sb.append("    image2x: ").append(toIndentedString(this.image2x)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
