package com.example.model;

/**
 * A summary of an article from the library.
 */
@io.swagger.annotations.ApiModel(value = "ArticleSummary", description = "A summary of an article from the library.")
@javax.xml.bind.annotation.XmlRootElement(name = "ArticleSummary")
@com.fasterxml.jackson.annotation.JsonSubTypes({
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.Article.class, name = "Article"),
})
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class ArticleSummary implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.UUID id = null;
	private java.lang.String name = null;
	private java.lang.String teaser = null;
	private com.example.model.Image thumbnail = null;
	
	/**
	 */
	public ArticleSummary id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("id")
	@javax.validation.constraints.NotNull
	public java.util.UUID getId() {
		return this.id;
	}
	public void setId(java.util.UUID id) {
		this.id = id;
	}
	
	/**
	 */
	public ArticleSummary name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("name")
	@javax.validation.constraints.NotNull
	public java.lang.String getName() {
		return this.name;
	}
	public void setName(java.lang.String name) {
		this.name = name;
	}
	
	/**
	 */
	public ArticleSummary teaser(java.lang.String teaser) {
		setTeaser(teaser);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("teaser")
	public java.lang.String getTeaser() {
		return this.teaser;
	}
	public void setTeaser(java.lang.String teaser) {
		this.teaser = teaser;
	}
	
	/**
	 * A URL to a thumbnail image for this article.
	 */
	public ArticleSummary thumbnail(com.example.model.Image thumbnail) {
		setThumbnail(thumbnail);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "A URL to a thumbnail image for this article.")
	@com.fasterxml.jackson.annotation.JsonProperty("thumbnail")
	@javax.validation.Valid
	public com.example.model.Image getThumbnail() {
		return this.thumbnail;
	}
	public void setThumbnail(com.example.model.Image thumbnail) {
		this.thumbnail = thumbnail;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		ArticleSummary articleSummary = (ArticleSummary) o;
		return java.util.Objects.equals(this.id, articleSummary.id) &&
				java.util.Objects.equals(this.name, articleSummary.name) &&
				java.util.Objects.equals(this.teaser, articleSummary.teaser) &&
				java.util.Objects.equals(this.thumbnail, articleSummary.thumbnail);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.id, this.name, this.teaser, this.thumbnail);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class ArticleSummary {\n");
		
		sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
		sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
		sb.append("    teaser: ").append(toIndentedString(this.teaser)).append("\n");
		sb.append("    thumbnail: ").append(toIndentedString(this.thumbnail)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
