package com.example.model;

@io.swagger.annotations.ApiModel(value = "FreeTextQuestion")
@javax.xml.bind.annotation.XmlRootElement(name = "FreeTextQuestion")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class FreeTextQuestion extends com.example.model.Question implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@javax.xml.bind.annotation.XmlType(name = "FreeTextTypeEnum")
	@javax.xml.bind.annotation.XmlEnum(java.lang.String.class)
	public enum FreeTextTypeEnum {
		@javax.xml.bind.annotation.XmlEnumValue("short") SHORT("short"), 
		@javax.xml.bind.annotation.XmlEnumValue("long") LONG("long");
		
		private java.lang.String value;
		
		FreeTextTypeEnum(java.lang.String v) {
			value = v;
		}
		
		@com.fasterxml.jackson.annotation.JsonValue
		public String value() {
			return value;
		}
		
		@Override
		public String toString() {
			return String.valueOf(value);
		}
		
		public static FreeTextTypeEnum fromValue(String v) {
			for (FreeTextTypeEnum b : FreeTextTypeEnum.values()) {
				if (String.valueOf(b.value).equals(v)) {
					return b;
				}
			}
			return null;
		}
	}
	
	private com.example.model.FreeTextQuestion.FreeTextTypeEnum freeTextType = null;
	
	/**
	 * question id
	 */
	@java.lang.Override
	public FreeTextQuestion id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	/**
	 * question title, e.g. How long have you worked for this organisation?
	 */
	@java.lang.Override
	public FreeTextQuestion title(java.lang.String title) {
		setTitle(title);
		return this;
	}
	
	/**
	 * Extra text to go underneath the title to clarify something about the question.
	 */
	@java.lang.Override
	public FreeTextQuestion subtitle(java.lang.String subtitle) {
		setSubtitle(subtitle);
		return this;
	}
	
	/**
	 * Introductory text to the question.
	 */
	@java.lang.Override
	public FreeTextQuestion introduction(java.lang.String introduction) {
		setIntroduction(introduction);
		return this;
	}
	
	/**
	 * index of answer option in options array/within min-max range
	 */
	@java.lang.Override
	public FreeTextQuestion answerIndex(java.lang.Integer answerIndex) {
		setAnswerIndex(answerIndex);
		return this;
	}
	
	/**
	 * index of answer option in options array/within min-max range
	 */
	@java.lang.Override
	public FreeTextQuestion answerIndices(java.util.List<java.lang.Integer> answerIndices) {
		setAnswerIndices(answerIndices);
		return this;
	}
	
	/**
	 * when available, string value that was put as an answer
	 */
	@java.lang.Override
	public FreeTextQuestion answeredStringValue(java.lang.String answeredStringValue) {
		setAnsweredStringValue(answeredStringValue);
		return this;
	}
	
	/**
	 * when available, whether the user chose to mark this question as not applicable
	 */
	@java.lang.Override
	public FreeTextQuestion answerNotApplicable(java.lang.Boolean answerNotApplicable) {
		setAnswerNotApplicable(answerNotApplicable);
		return this;
	}
	
	/**
	 * when matrix sub-question is set to requiresOtherTitle and participant has answered the question and provided other title, it will be set here.
	 */
	@java.lang.Override
	public FreeTextQuestion otherTitle(java.lang.String otherTitle) {
		setOtherTitle(otherTitle);
		return this;
	}
	
	/**
	 * indicates that the answer is not compulsory
	 */
	@java.lang.Override
	public FreeTextQuestion optional(java.lang.Boolean optional) {
		setOptional(optional);
		return this;
	}
	
	/**
	 * indicates that the question is created as a part of custom question
	 */
	@java.lang.Override
	public FreeTextQuestion custom(java.lang.Boolean custom) {
		setCustom(custom);
		return this;
	}
	
	/**
	 * indicates that the question is custom question and is a part of open survey, therefore it can&#x27;t be edited
	 */
	@java.lang.Override
	public FreeTextQuestion locked(java.lang.Boolean locked) {
		setLocked(locked);
		return this;
	}
	
	/**
	 */
	public FreeTextQuestion freeTextType(com.example.model.FreeTextQuestion.FreeTextTypeEnum freeTextType) {
		setFreeTextType(freeTextType);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("freeTextType")
	@javax.validation.constraints.NotNull
	public com.example.model.FreeTextQuestion.FreeTextTypeEnum getFreeTextType() {
		return this.freeTextType;
	}
	public void setFreeTextType(com.example.model.FreeTextQuestion.FreeTextTypeEnum freeTextType) {
		this.freeTextType = freeTextType;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		if (!super.equals(o)) {
			return false;
		}
		FreeTextQuestion freeTextQuestion = (FreeTextQuestion) o;
		return java.util.Objects.equals(this.freeTextType, freeTextQuestion.freeTextType);
	}
	
	@Override
	public int hashCode() {
		return 31 * super.hashCode() + java.util.Objects.hash(this.freeTextType);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class FreeTextQuestion {\n");
		sb.append("    ").append(toIndentedString(super.toString())).append("\n");
		sb.append("    freeTextType: ").append(toIndentedString(this.freeTextType)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
