package com.example.model;

@io.swagger.annotations.ApiModel(value = "MatrixQuestion")
@javax.xml.bind.annotation.XmlRootElement(name = "MatrixQuestion")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class MatrixQuestion implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.UUID id = null;
	private java.lang.String title = null;
	private java.lang.String subtitle = null;
	private java.lang.String introduction = null;
	private java.lang.Integer answerIndex = null;
	private java.util.List<java.lang.Integer> answerIndices = null;
	private java.lang.String answeredStringValue = null;
	private java.lang.Boolean answerNotApplicable = null;
	private java.lang.String otherTitle = null;
	private java.lang.Boolean optional = null;
	private java.lang.Boolean custom = null;
	private java.lang.Boolean locked = null;
	private int min = 0;
	private int max = 0;
	private java.util.List<java.lang.String> labels = new java.util.ArrayList<java.lang.String>();
	private boolean requiresOtherTitle = false;
	private java.util.List<com.example.model.MatrixSubQuestion> subquestions = new java.util.ArrayList<com.example.model.MatrixSubQuestion>();
	
	/**
	 * question id
	 */
	public MatrixQuestion id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "question id")
	@com.fasterxml.jackson.annotation.JsonProperty("id")
	@javax.validation.constraints.NotNull
	public java.util.UUID getId() {
		return this.id;
	}
	public void setId(java.util.UUID id) {
		this.id = id;
	}
	
	/**
	 * question title, e.g. How long have you worked for this organisation?
	 */
	public MatrixQuestion title(java.lang.String title) {
		setTitle(title);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "question title, e.g. How long have you worked for this organisation?")
	@com.fasterxml.jackson.annotation.JsonProperty("title")
	@javax.validation.constraints.NotNull
	public java.lang.String getTitle() {
		return this.title;
	}
	public void setTitle(java.lang.String title) {
		this.title = title;
	}
	
	/**
	 * Extra text to go underneath the title to clarify something about the question.
	 */
	public MatrixQuestion subtitle(java.lang.String subtitle) {
		setSubtitle(subtitle);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Extra text to go underneath the title to clarify something about the question.")
	@com.fasterxml.jackson.annotation.JsonProperty("subtitle")
	public java.lang.String getSubtitle() {
		return this.subtitle;
	}
	public void setSubtitle(java.lang.String subtitle) {
		this.subtitle = subtitle;
	}
	
	/**
	 * Introductory text to the question.
	 */
	public MatrixQuestion introduction(java.lang.String introduction) {
		setIntroduction(introduction);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Introductory text to the question.")
	@com.fasterxml.jackson.annotation.JsonProperty("introduction")
	public java.lang.String getIntroduction() {
		return this.introduction;
	}
	public void setIntroduction(java.lang.String introduction) {
		this.introduction = introduction;
	}
	
	/**
	 * index of answer option in options array/within min-max range
	 */
	public MatrixQuestion answerIndex(java.lang.Integer answerIndex) {
		setAnswerIndex(answerIndex);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "index of answer option in options array/within min-max range")
	@com.fasterxml.jackson.annotation.JsonProperty("answerIndex")
	public java.lang.Integer getAnswerIndex() {
		return this.answerIndex;
	}
	public void setAnswerIndex(java.lang.Integer answerIndex) {
		this.answerIndex = answerIndex;
	}
	
	/**
	 * index of answer option in options array/within min-max range
	 */
	public MatrixQuestion answerIndices(java.util.List<java.lang.Integer> answerIndices) {
		setAnswerIndices(answerIndices);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "index of answer option in options array/within min-max range")
	@com.fasterxml.jackson.annotation.JsonProperty("answerIndices")
	@javax.validation.Valid
	public java.util.List<java.lang.Integer> getAnswerIndices() {
		return this.answerIndices;
	}
	public void setAnswerIndices(java.util.List<java.lang.Integer> answerIndices) {
		this.answerIndices = answerIndices;
	}
	public void addAnswerIndex(int answerIndex) {
		if (this.answerIndices == null) {
			this.answerIndices = new java.util.ArrayList<java.lang.Integer>();
		}
		this.answerIndices.add(answerIndex);
	}
	
	/**
	 * when available, string value that was put as an answer
	 */
	public MatrixQuestion answeredStringValue(java.lang.String answeredStringValue) {
		setAnsweredStringValue(answeredStringValue);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "when available, string value that was put as an answer")
	@com.fasterxml.jackson.annotation.JsonProperty("answeredStringValue")
	public java.lang.String getAnsweredStringValue() {
		return this.answeredStringValue;
	}
	public void setAnsweredStringValue(java.lang.String answeredStringValue) {
		this.answeredStringValue = answeredStringValue;
	}
	
	/**
	 * when available, whether the user chose to mark this question as not applicable
	 */
	public MatrixQuestion answerNotApplicable(java.lang.Boolean answerNotApplicable) {
		setAnswerNotApplicable(answerNotApplicable);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "when available, whether the user chose to mark this question as not applicable")
	@com.fasterxml.jackson.annotation.JsonProperty("answerNotApplicable")
	public java.lang.Boolean getAnswerNotApplicable() {
		return this.answerNotApplicable;
	}
	public void setAnswerNotApplicable(java.lang.Boolean answerNotApplicable) {
		this.answerNotApplicable = answerNotApplicable;
	}
	
	/**
	 * when matrix sub-question is set to requiresOtherTitle and participant has answered the question and provided other title, it will be set here.
	 */
	public MatrixQuestion otherTitle(java.lang.String otherTitle) {
		setOtherTitle(otherTitle);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "when matrix sub-question is set to requiresOtherTitle and participant has answered the question and provided other title, it will be set here.")
	@com.fasterxml.jackson.annotation.JsonProperty("otherTitle")
	public java.lang.String getOtherTitle() {
		return this.otherTitle;
	}
	public void setOtherTitle(java.lang.String otherTitle) {
		this.otherTitle = otherTitle;
	}
	
	/**
	 * indicates that the answer is not compulsory
	 */
	public MatrixQuestion optional(java.lang.Boolean optional) {
		setOptional(optional);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "indicates that the answer is not compulsory")
	@com.fasterxml.jackson.annotation.JsonProperty("optional")
	public java.lang.Boolean getOptional() {
		return this.optional;
	}
	public void setOptional(java.lang.Boolean optional) {
		this.optional = optional;
	}
	
	/**
	 * indicates that the question is created as a part of custom question
	 */
	public MatrixQuestion custom(java.lang.Boolean custom) {
		setCustom(custom);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "indicates that the question is created as a part of custom question")
	@com.fasterxml.jackson.annotation.JsonProperty("custom")
	public java.lang.Boolean getCustom() {
		return this.custom;
	}
	public void setCustom(java.lang.Boolean custom) {
		this.custom = custom;
	}
	
	/**
	 * indicates that the question is custom question and is a part of open survey, therefore it can&#x27;t be edited
	 */
	public MatrixQuestion locked(java.lang.Boolean locked) {
		setLocked(locked);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "indicates that the question is custom question and is a part of open survey, therefore it can't be edited")
	@com.fasterxml.jackson.annotation.JsonProperty("locked")
	public java.lang.Boolean getLocked() {
		return this.locked;
	}
	public void setLocked(java.lang.Boolean locked) {
		this.locked = locked;
	}
	
	/**
	 * minimum value for scale question and matrix question
	 */
	public MatrixQuestion min(int min) {
		setMin(min);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "minimum value for scale question and matrix question")
	@com.fasterxml.jackson.annotation.JsonProperty("min")
	@javax.validation.constraints.NotNull
	public int getMin() {
		return this.min;
	}
	public void setMin(int min) {
		this.min = min;
	}
	
	/**
	 * maximum value for scale question and matrix question
	 */
	public MatrixQuestion max(int max) {
		setMax(max);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "maximum value for scale question and matrix question")
	@com.fasterxml.jackson.annotation.JsonProperty("max")
	@javax.validation.constraints.NotNull
	public int getMax() {
		return this.max;
	}
	public void setMax(int max) {
		this.max = max;
	}
	
	/**
	 * array of labels of scale question and matrix question
	 */
	public MatrixQuestion labels(java.util.List<java.lang.String> labels) {
		setLabels(labels);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "array of labels of scale question and matrix question")
	@com.fasterxml.jackson.annotation.JsonProperty("labels")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<java.lang.String> getLabels() {
		return this.labels;
	}
	public void setLabels(java.util.List<java.lang.String> labels) {
		this.labels = labels;
	}
	public void addLabel(java.lang.String label) {
		if (this.labels == null) {
			this.labels = new java.util.ArrayList<java.lang.String>();
		}
		this.labels.add(label);
	}
	
	/**
	 * true if matrix sub-question or scale question require user to set title
	 */
	public MatrixQuestion requiresOtherTitle(boolean requiresOtherTitle) {
		setRequiresOtherTitle(requiresOtherTitle);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "true if matrix sub-question or scale question require user to set title")
	@com.fasterxml.jackson.annotation.JsonProperty("requiresOtherTitle")
	@javax.validation.constraints.NotNull
	public boolean isRequiresOtherTitle() {
		return this.requiresOtherTitle;
	}
	public void setRequiresOtherTitle(boolean requiresOtherTitle) {
		this.requiresOtherTitle = requiresOtherTitle;
	}
	
	/**
	 * matrix question contains subquestions, those would be contained as subquestions here
	 */
	public MatrixQuestion subquestions(java.util.List<com.example.model.MatrixSubQuestion> subquestions) {
		setSubquestions(subquestions);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "matrix question contains subquestions, those would be contained as subquestions here")
	@com.fasterxml.jackson.annotation.JsonProperty("subquestions")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<com.example.model.MatrixSubQuestion> getSubquestions() {
		return this.subquestions;
	}
	public void setSubquestions(java.util.List<com.example.model.MatrixSubQuestion> subquestions) {
		this.subquestions = subquestions;
	}
	public void addSubquestion(com.example.model.MatrixSubQuestion subquestion) {
		if (this.subquestions == null) {
			this.subquestions = new java.util.ArrayList<com.example.model.MatrixSubQuestion>();
		}
		this.subquestions.add(subquestion);
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		MatrixQuestion matrixQuestion = (MatrixQuestion) o;
		return java.util.Objects.equals(this.id, matrixQuestion.id) &&
				java.util.Objects.equals(this.title, matrixQuestion.title) &&
				java.util.Objects.equals(this.subtitle, matrixQuestion.subtitle) &&
				java.util.Objects.equals(this.introduction, matrixQuestion.introduction) &&
				java.util.Objects.equals(this.answerIndex, matrixQuestion.answerIndex) &&
				java.util.Objects.equals(this.answerIndices, matrixQuestion.answerIndices) &&
				java.util.Objects.equals(this.answeredStringValue, matrixQuestion.answeredStringValue) &&
				java.util.Objects.equals(this.answerNotApplicable, matrixQuestion.answerNotApplicable) &&
				java.util.Objects.equals(this.otherTitle, matrixQuestion.otherTitle) &&
				java.util.Objects.equals(this.optional, matrixQuestion.optional) &&
				java.util.Objects.equals(this.custom, matrixQuestion.custom) &&
				java.util.Objects.equals(this.locked, matrixQuestion.locked) &&
				java.util.Objects.equals(this.min, matrixQuestion.min) &&
				java.util.Objects.equals(this.max, matrixQuestion.max) &&
				java.util.Objects.equals(this.labels, matrixQuestion.labels) &&
				java.util.Objects.equals(this.requiresOtherTitle, matrixQuestion.requiresOtherTitle) &&
				java.util.Objects.equals(this.subquestions, matrixQuestion.subquestions);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.id, this.title, this.subtitle, this.introduction, this.answerIndex, this.answerIndices, this.answeredStringValue, this.answerNotApplicable, this.otherTitle, this.optional, this.custom, this.locked, this.min, this.max, this.labels, this.requiresOtherTitle, this.subquestions);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class MatrixQuestion {\n");
		
		sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
		sb.append("    title: ").append(toIndentedString(this.title)).append("\n");
		sb.append("    subtitle: ").append(toIndentedString(this.subtitle)).append("\n");
		sb.append("    introduction: ").append(toIndentedString(this.introduction)).append("\n");
		sb.append("    answerIndex: ").append(toIndentedString(this.answerIndex)).append("\n");
		sb.append("    answerIndices: ").append(toIndentedString(this.answerIndices)).append("\n");
		sb.append("    answeredStringValue: ").append(toIndentedString(this.answeredStringValue)).append("\n");
		sb.append("    answerNotApplicable: ").append(toIndentedString(this.answerNotApplicable)).append("\n");
		sb.append("    otherTitle: ").append(toIndentedString(this.otherTitle)).append("\n");
		sb.append("    optional: ").append(toIndentedString(this.optional)).append("\n");
		sb.append("    custom: ").append(toIndentedString(this.custom)).append("\n");
		sb.append("    locked: ").append(toIndentedString(this.locked)).append("\n");
		sb.append("    min: ").append(toIndentedString(this.min)).append("\n");
		sb.append("    max: ").append(toIndentedString(this.max)).append("\n");
		sb.append("    labels: ").append(toIndentedString(this.labels)).append("\n");
		sb.append("    requiresOtherTitle: ").append(toIndentedString(this.requiresOtherTitle)).append("\n");
		sb.append("    subquestions: ").append(toIndentedString(this.subquestions)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
