package com.example.model;

/**
 * A group of participants
 */
@io.swagger.annotations.ApiModel(value = "ParticipantGroup", description = "A group of participants")
@javax.xml.bind.annotation.XmlRootElement(name = "ParticipantGroup")
@com.fasterxml.jackson.annotation.JsonSubTypes({
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.GetGroups200Response.Group.class, name = "Group"),
})
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class ParticipantGroup implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@javax.xml.bind.annotation.XmlType(name = "GroupTypeEnum")
	@javax.xml.bind.annotation.XmlEnum(java.lang.String.class)
	public enum GroupTypeEnum {
		@javax.xml.bind.annotation.XmlEnumValue("regular") REGULAR("regular"), 
		@javax.xml.bind.annotation.XmlEnumValue("allParticipants") ALL_PARTICIPANTS("allParticipants");
		
		private java.lang.String value;
		
		GroupTypeEnum(java.lang.String v) {
			value = v;
		}
		
		@com.fasterxml.jackson.annotation.JsonValue
		public String value() {
			return value;
		}
		
		@Override
		public String toString() {
			return String.valueOf(value);
		}
		
		public static GroupTypeEnum fromValue(String v) {
			for (GroupTypeEnum b : GroupTypeEnum.values()) {
				if (String.valueOf(b.value).equals(v)) {
					return b;
				}
			}
			return null;
		}
	}
	
	private java.util.UUID id = null;
	private java.lang.String name = null;
	private int count = 0;
	private com.example.model.ParticipantGroup.GroupTypeEnum groupType = null;
	private boolean canDelete = false;
	
	/**
	 */
	public ParticipantGroup id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("id")
	@javax.validation.constraints.NotNull
	public java.util.UUID getId() {
		return this.id;
	}
	public void setId(java.util.UUID id) {
		this.id = id;
	}
	
	/**
	 */
	public ParticipantGroup name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("name")
	@javax.validation.constraints.NotNull
	public java.lang.String getName() {
		return this.name;
	}
	public void setName(java.lang.String name) {
		this.name = name;
	}
	
	/**
	 * The number of participants in the group.
	 */
	public ParticipantGroup count(int count) {
		setCount(count);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "The number of participants in the group.")
	@com.fasterxml.jackson.annotation.JsonProperty("count")
	@javax.validation.constraints.NotNull
	public int getCount() {
		return this.count;
	}
	public void setCount(int count) {
		this.count = count;
	}
	
	/**
	 */
	public ParticipantGroup groupType(com.example.model.ParticipantGroup.GroupTypeEnum groupType) {
		setGroupType(groupType);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("groupType")
	@javax.validation.constraints.NotNull
	public com.example.model.ParticipantGroup.GroupTypeEnum getGroupType() {
		return this.groupType;
	}
	public void setGroupType(com.example.model.ParticipantGroup.GroupTypeEnum groupType) {
		this.groupType = groupType;
	}
	
	/**
	 */
	public ParticipantGroup canDelete(boolean canDelete) {
		setCanDelete(canDelete);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("canDelete")
	@javax.validation.constraints.NotNull
	public boolean isCanDelete() {
		return this.canDelete;
	}
	public void setCanDelete(boolean canDelete) {
		this.canDelete = canDelete;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		ParticipantGroup participantGroup = (ParticipantGroup) o;
		return java.util.Objects.equals(this.id, participantGroup.id) &&
				java.util.Objects.equals(this.name, participantGroup.name) &&
				java.util.Objects.equals(this.count, participantGroup.count) &&
				java.util.Objects.equals(this.groupType, participantGroup.groupType) &&
				java.util.Objects.equals(this.canDelete, participantGroup.canDelete);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.id, this.name, this.count, this.groupType, this.canDelete);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class ParticipantGroup {\n");
		
		sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
		sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
		sb.append("    count: ").append(toIndentedString(this.count)).append("\n");
		sb.append("    groupType: ").append(toIndentedString(this.groupType)).append("\n");
		sb.append("    canDelete: ").append(toIndentedString(this.canDelete)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
