package com.example.model;

/**
 * The survey information for a participation.
 */
@io.swagger.annotations.ApiModel(value = "ParticipationSurvey", description = "The survey information for a participation.")
@javax.xml.bind.annotation.XmlRootElement(name = "ParticipationSurvey")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class ParticipationSurvey implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@javax.xml.bind.annotation.XmlType(name = "StatusEnum")
	@javax.xml.bind.annotation.XmlEnum(java.lang.String.class)
	public enum StatusEnum {
		@javax.xml.bind.annotation.XmlEnumValue("pending") PENDING("pending"), 
		@javax.xml.bind.annotation.XmlEnumValue("open") OPEN("open"), 
		@javax.xml.bind.annotation.XmlEnumValue("closed") CLOSED("closed");
		
		private java.lang.String value;
		
		StatusEnum(java.lang.String v) {
			value = v;
		}
		
		@com.fasterxml.jackson.annotation.JsonValue
		public String value() {
			return value;
		}
		
		@Override
		public String toString() {
			return String.valueOf(value);
		}
		
		public static StatusEnum fromValue(String v) {
			for (StatusEnum b : StatusEnum.values()) {
				if (String.valueOf(b.value).equals(v)) {
					return b;
				}
			}
			return null;
		}
	}
	
	@io.swagger.annotations.ApiModel(value = "")
	public static class Section implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		private java.lang.String name = null;
		private java.lang.String intro = null;
		private java.util.List<com.example.model.Question> questions = new java.util.ArrayList<com.example.model.Question>();
		
		/**
		 */
		public Section name(java.lang.String name) {
			setName(name);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("name")
		@javax.validation.constraints.NotNull
		public java.lang.String getName() {
			return this.name;
		}
		public void setName(java.lang.String name) {
			this.name = name;
		}
		
		/**
		 */
		public Section intro(java.lang.String intro) {
			setIntro(intro);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("intro")
		public java.lang.String getIntro() {
			return this.intro;
		}
		public void setIntro(java.lang.String intro) {
			this.intro = intro;
		}
		
		/**
		 */
		public Section questions(java.util.List<com.example.model.Question> questions) {
			setQuestions(questions);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("questions")
		@javax.validation.Valid
		@javax.validation.constraints.NotNull
		public java.util.List<com.example.model.Question> getQuestions() {
			return this.questions;
		}
		public void setQuestions(java.util.List<com.example.model.Question> questions) {
			this.questions = questions;
		}
		public void addQuestion(com.example.model.Question question) {
			if (this.questions == null) {
				this.questions = new java.util.ArrayList<com.example.model.Question>();
			}
			this.questions.add(question);
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Section section = (Section) o;
			return java.util.Objects.equals(this.name, section.name) &&
					java.util.Objects.equals(this.intro, section.intro) &&
					java.util.Objects.equals(this.questions, section.questions);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.name, this.intro, this.questions);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Section {\n");
			
			sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
			sb.append("    intro: ").append(toIndentedString(this.intro)).append("\n");
			sb.append("    questions: ").append(toIndentedString(this.questions)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	@io.swagger.annotations.ApiModel(value = "")
	public static class Contact implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		private java.lang.String name = null;
		private java.lang.String email = null;
		
		/**
		 */
		public Contact name(java.lang.String name) {
			setName(name);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("name")
		@javax.validation.constraints.NotNull
		public java.lang.String getName() {
			return this.name;
		}
		public void setName(java.lang.String name) {
			this.name = name;
		}
		
		/**
		 */
		public Contact email(java.lang.String email) {
			setEmail(email);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("email")
		@javax.validation.constraints.NotNull
		@javax.validation.constraints.Email
		public java.lang.String getEmail() {
			return this.email;
		}
		public void setEmail(java.lang.String email) {
			this.email = email;
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Contact contact = (Contact) o;
			return java.util.Objects.equals(this.name, contact.name) &&
					java.util.Objects.equals(this.email, contact.email);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.name, this.email);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Contact {\n");
			
			sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
			sb.append("    email: ").append(toIndentedString(this.email)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	private java.lang.String name = null;
	private java.lang.String welcome = null;
	private java.lang.Integer expectedDuration = null;
	private com.example.model.ParticipationSurvey.StatusEnum status = null;
	private java.time.OffsetDateTime dueDate = null;
	private java.util.List<com.example.model.ParticipationSurvey.Section> sections = new java.util.ArrayList<com.example.model.ParticipationSurvey.Section>();
	private com.example.model.AccountSummary account = null;
	private com.example.model.ParticipationSurvey.Contact contact = null;
	private java.lang.String privacyStatementHtml = null;
	
	/**
	 */
	public ParticipationSurvey name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("name")
	@javax.validation.constraints.NotNull
	public java.lang.String getName() {
		return this.name;
	}
	public void setName(java.lang.String name) {
		this.name = name;
	}
	
	/**
	 */
	public ParticipationSurvey welcome(java.lang.String welcome) {
		setWelcome(welcome);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("welcome")
	public java.lang.String getWelcome() {
		return this.welcome;
	}
	public void setWelcome(java.lang.String welcome) {
		this.welcome = welcome;
	}
	
	/**
	 */
	public ParticipationSurvey expectedDuration(java.lang.Integer expectedDuration) {
		setExpectedDuration(expectedDuration);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("expectedDuration")
	public java.lang.Integer getExpectedDuration() {
		return this.expectedDuration;
	}
	public void setExpectedDuration(java.lang.Integer expectedDuration) {
		this.expectedDuration = expectedDuration;
	}
	
	/**
	 */
	public ParticipationSurvey status(com.example.model.ParticipationSurvey.StatusEnum status) {
		setStatus(status);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("status")
	@javax.validation.constraints.NotNull
	public com.example.model.ParticipationSurvey.StatusEnum getStatus() {
		return this.status;
	}
	public void setStatus(com.example.model.ParticipationSurvey.StatusEnum status) {
		this.status = status;
	}
	
	/**
	 */
	public ParticipationSurvey dueDate(java.time.OffsetDateTime dueDate) {
		setDueDate(dueDate);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("dueDate")
	public java.time.OffsetDateTime getDueDate() {
		return this.dueDate;
	}
	public void setDueDate(java.time.OffsetDateTime dueDate) {
		this.dueDate = dueDate;
	}
	
	/**
	 */
	public ParticipationSurvey sections(java.util.List<com.example.model.ParticipationSurvey.Section> sections) {
		setSections(sections);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("sections")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<com.example.model.ParticipationSurvey.Section> getSections() {
		return this.sections;
	}
	public void setSections(java.util.List<com.example.model.ParticipationSurvey.Section> sections) {
		this.sections = sections;
	}
	public void addSection(com.example.model.ParticipationSurvey.Section section) {
		if (this.sections == null) {
			this.sections = new java.util.ArrayList<com.example.model.ParticipationSurvey.Section>();
		}
		this.sections.add(section);
	}
	
	/**
	 */
	public ParticipationSurvey account(com.example.model.AccountSummary account) {
		setAccount(account);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("account")
	@javax.validation.Valid
	public com.example.model.AccountSummary getAccount() {
		return this.account;
	}
	public void setAccount(com.example.model.AccountSummary account) {
		this.account = account;
	}
	
	/**
	 */
	public ParticipationSurvey contact(com.example.model.ParticipationSurvey.Contact contact) {
		setContact(contact);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("contact")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public com.example.model.ParticipationSurvey.Contact getContact() {
		return this.contact;
	}
	public void setContact(com.example.model.ParticipationSurvey.Contact contact) {
		this.contact = contact;
	}
	
	/**
	 */
	public ParticipationSurvey privacyStatementHtml(java.lang.String privacyStatementHtml) {
		setPrivacyStatementHtml(privacyStatementHtml);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("privacyStatementHtml")
	public java.lang.String getPrivacyStatementHtml() {
		return this.privacyStatementHtml;
	}
	public void setPrivacyStatementHtml(java.lang.String privacyStatementHtml) {
		this.privacyStatementHtml = privacyStatementHtml;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		ParticipationSurvey participationSurvey = (ParticipationSurvey) o;
		return java.util.Objects.equals(this.name, participationSurvey.name) &&
				java.util.Objects.equals(this.welcome, participationSurvey.welcome) &&
				java.util.Objects.equals(this.expectedDuration, participationSurvey.expectedDuration) &&
				java.util.Objects.equals(this.status, participationSurvey.status) &&
				java.util.Objects.equals(this.dueDate, participationSurvey.dueDate) &&
				java.util.Objects.equals(this.sections, participationSurvey.sections) &&
				java.util.Objects.equals(this.account, participationSurvey.account) &&
				java.util.Objects.equals(this.contact, participationSurvey.contact) &&
				java.util.Objects.equals(this.privacyStatementHtml, participationSurvey.privacyStatementHtml);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.name, this.welcome, this.expectedDuration, this.status, this.dueDate, this.sections, this.account, this.contact, this.privacyStatementHtml);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class ParticipationSurvey {\n");
		
		sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
		sb.append("    welcome: ").append(toIndentedString(this.welcome)).append("\n");
		sb.append("    expectedDuration: ").append(toIndentedString(this.expectedDuration)).append("\n");
		sb.append("    status: ").append(toIndentedString(this.status)).append("\n");
		sb.append("    dueDate: ").append(toIndentedString(this.dueDate)).append("\n");
		sb.append("    sections: ").append(toIndentedString(this.sections)).append("\n");
		sb.append("    account: ").append(toIndentedString(this.account)).append("\n");
		sb.append("    contact: ").append(toIndentedString(this.contact)).append("\n");
		sb.append("    privacyStatementHtml: ").append(toIndentedString(this.privacyStatementHtml)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
