package com.example;

import javax.ws.rs.core.Response;

import org.apache.cxf.endpoint.Server;
import org.apache.cxf.jaxrs.client.JAXRSClientFactory;
import org.apache.cxf.jaxrs.client.WebClient;
import org.apache.cxf.jaxrs.spring.JAXRSServerFactoryBeanDefinitionParser.SpringJAXRSServerFactoryBean;
import org.apache.cxf.transport.local.LocalConduit;
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = { TestConfiguration.class })
public class PersonApiTest {
	
	private static Server server;
	private com.example.PersonApi api;
	
	@Autowired
	private SpringJAXRSServerFactoryBean serverFactory;

	@Before
	public void setup() throws Exception {
		server = serverFactory.create();
		api = JAXRSClientFactory.create(TestConfiguration.ENDPOINT_ADDRESS, com.example.PersonApi.class, TestConfiguration.defaultProviders());
		WebClient.getConfig(api).getRequestContext().put(LocalConduit.DIRECT_DISPATCH, Boolean.TRUE);
	}
	
	@After
	public void destroy() throws Exception {
		server.stop();
		server.destroy();
	}
	
	@Test
	public void confirmTotpTest() {

		Response response = this.api.confirmTotp();
		Assert.assertNotNull(response);
	}

	@Test
	public void getMyDetailsTest() {

		Response response = this.api.getMyDetails();
		Assert.assertNotNull(response);
		com.example.model.PersonDetails result = response.readEntity(com.example.model.PersonDetails.class);
		Assert.assertNotNull(result);
	}

	@Test
	public void startTotpTest() {

		Response response = this.api.startTotp();
		Assert.assertNotNull(response);
		com.example.model.StartTotp200Response result = response.readEntity(com.example.model.StartTotp200Response.class);
		Assert.assertNotNull(result);
	}

	@Test
	public void updateMyDetailsTest() {

		Response response = this.api.updateMyDetails();
		Assert.assertNotNull(response);
		com.example.model.PersonDetails result = response.readEntity(com.example.model.PersonDetails.class);
		Assert.assertNotNull(result);
	}

}
